From 4e1c9f59645097b88a0a48d3e8c288e067db0804 Mon Sep 17 00:00:00 2001
From: Joel Grunbaum <joelgrun@gmail.com>
Date: Sat, 24 Oct 2020 03:08:14 +0000
Subject: [PATCH] Relicensed to MIT

---
 main.sh |  201 +++++++++++++++++++++++++++++++++-----------------
 1 files changed, 133 insertions(+), 68 deletions(-)

diff --git a/main.sh b/main.sh
index 7e7f635..1cd4aef 100755
--- a/main.sh
+++ b/main.sh
@@ -1,49 +1,53 @@
 #!/bin/bash
 #A basic bash script to automate the building of arch packages
-# Usage: main.sh init|add|build_all [-f force]
+# Usage: main.sh init|check|add|remove|build_all
 
 source $(dirname "$(realpath $0)")/vars.sh
+
+ERRORFILE=$(mktemp)
+WAITLIST=$(mktemp)
+WAITLIST_LCK=$(mktemp)
 
 #Helper for finding newest and oldest files
 #Sourced from stack overflow
 # Usage: newold_matching_file [n/o] [filename]
 function newold_matching_file
 {
-    # Use ${1-} instead of $1 in case 'nounset' is set
-    local -r glob_pattern=${2-}
+	# Use ${1-} instead of $1 in case 'nounset' is set
+	local -r glob_pattern=${2-}
 
-    # To avoid printing garbage if no files match the pattern, set
-    # 'nullglob' if necessary
-    local -i need_to_unset_nullglob=0
-    if [[ ":$BASHOPTS:" != *:nullglob:* ]] ; then
-        shopt -s nullglob
-        need_to_unset_nullglob=1
-    fi
+	# To avoid printing garbage if no files match the pattern, set
+	# 'nullglob' if necessary
+	local -i need_to_unset_nullglob=0
+	if [[ ":$BASHOPTS:" != *:nullglob:* ]] ; then
+		shopt -s nullglob
+		need_to_unset_nullglob=1
+	fi
 
-    file=
-    for f in $glob_pattern ; do
+	file=
+	for f in $glob_pattern ; do
 		if [ $1 == "n" ]; then
 			[[ -z $f || $f -nt $_file ]] && file=$f
 		elif [ $1 == "o" ]; then
 			[[ -z $f || $f -ot $_file ]] && file=$f
 		fi
-    done
+	done
 
-    # To avoid unexpected behaviour elsewhere, unset nullglob if it was
-    # set by this function
-    (( need_to_unset_nullglob )) && shopt -u nullglob
+	# To avoid unexpected behaviour elsewhere, unset nullglob if it was
+	# set by this function
+	(( need_to_unset_nullglob )) && shopt -u nullglob
 
-    # Use printf instead of echo in case the file name begins with '-'
-    [[ -n $file ]] && printf '%s\n' "$file"
+	# Use printf instead of echo in case the file name begins with '-'
+	[[ -n $file ]] && printf '%s\n' "$file"
 
-    return 0
+	return 0
 }
 
 #Build latest version of a package
 # Usage: build_pkg [package name] [-f force]
 function build_pkg {
 	#check if PKGBUILD has updated, don't rebuild if hasn't changed
-	if [[ ! -z $(git pull | grep "Already up to date.") && -z $(echo $1 | grep git) && -z $2 ]]; then
+	if [[ -n "$(git pull | grep 'Already up to date.')" && -z "$(grep 'pkgver[[:space:]]() {' PKGBUILD)" && -z "$2" ]]; then
 		return 2
 	fi
 
@@ -62,74 +66,91 @@
 	fi
 	if [[ $? != 0 ]]; then
 		#Register error
-		echo $1 >> $REPODIR/.errors
+		echo $1 >> $ERRORFILE
 		return 1
 	fi
 
-	#Get build artifact names
+	#Get build artifact names from PKGBUILD and build artifacts
+	#Remove duplicates from the list
 	source PKGBUILD
 	pkgs=()
+	ipkgs=()
 	for i in ${pkgname[@]}; do
 		#pkgs+=("$i-$pkgver-$pkgrel")
-		pkgs+=("$(find . -mindepth 1 -maxdepth 1 -type f -name "$1*.tar.*" -not -name "*.sig" | sed 's/^\.\///')")
+		ipkgs+=($(find . -mindepth 1 -maxdepth 1 -type f \( -name "$i*.pkg.tar.*" -o -name "$i*.src.tar.*" \) -not -name "*.sig" | sed 's/^\.\///'))
 	done
+	while read -r -d '' x; do pkgs+=("$x"); done < <(printf "%s\0" "${ipkgs[@]}" | sort -uz)
 
 	#Move package to repodir and add to repo db
 	#Dont change the database if rebuilt the same package at same release and version
+	flag=0
 	for i in ${pkgs[@]}; do
-		if [[ -f $REPODIR/$i ]]; then
-			pkgs=${pkgs[@]/$i}
-		else
-			rm -f $REPODIR/*$1*.tar.*
-			cp $i $REPODIR/
-			[[ "$SIGN" == "Y" ]] && cp $i.sig $REPODIR/
+		if [[ ! -f $REPODIR/$i ]]; then
+			flag=1
 		fi
 	done
+	if [[ $flag == 1 ]]; then
+		rm -f $REPODIR/*$1*.tar.*
+		for i in ${pkgs[@]}; do
+			cp $i $REPODIR/
+			[[ "$SIGN" == "Y" ]] && cp $i.sig $REPODIR/
+		done
+	else 
+		return;
+	fi
 
 	# Weird exceptions
 	if [[ "$1" == "zoom" ]]; then
 		rm zoom*_orig*.pkg.tar.xz
+		for i in ${pkgs[@]}; do
+			if [ -z "${i##*orig*}" ]; then
+				pkgs=${pkgs[@]/$i}
+			fi
+		done
 	fi
 
 	# Add package to waiting list to be added to repo db
 	while true; do
-		if [[ $(cat $REPODIR/.waitlist.lck) == 1 ]]; then
+		if [[ $(cat $WAITLIST_LCK) == 1 ]]; then
 			sleep 1
 		else
-			echo 1 > $REPODIR/.waitlist.lck
-			echo $1 >> $REPODIR/.waitlist
-			echo 0 > $REPODIR/.waitlist.lck
+			echo 1 > $WAITLIST_LCK
+			echo $1 >> $WAITLIST
+			echo 0 > $WAITLIST_LCK
 			break
 			fi
 	done
 	while true; do
 		# Wait until package is at the top of the queue and add to db
-		if [[ "$(head -n1 $REPODIR/.waitlist)" == "$1" ]]; then
-			for i in ${pkgs[@]}; do
-				repo-add $([[ "$SIGN" == "Y" ]] && echo "--sign --key $KEY") $REPODIR/$REPONAME.db.tar.$([ -n COMPRESSION ] || echo $COMPRESSION && echo zst) $REPODIR/$i
-			done
+		if [[ "$(head -n1 $WAITLIST)" == "$1" ]]; then
+		#	for i in ${pkgs[@]}; do
+				repo-add $([[ "$SIGN" == "Y" ]] && echo "--sign --key $KEY") $REPODIR/$REPONAME.db.tar.$([ -n "$COMPRESSION" ] || echo $COMPRESSION && echo zst) ${pkgs[@]}
+		#	done
 			while true; do
-				if [[ $(cat $REPODIR/.waitlist.lck) == 1 ]]; then
+				if [[ $(cat $WAITLIST_LCK) == 1 ]]; then
 					sleep 1
 				else
 					# Remove self from top of queue
-					echo 1 > $REPODIR/.waitlist.lck
-					tail -n +2 $REPODIR/.waitlist > $REPODIR/.waitlist.tmp
-					mv $REPODIR/.waitlist.tmp $REPODIR/.waitlist
-					echo 0 > $REPODIR/.waitlist.lck
+					echo 1 > $WAITLIST_LCK
+					TEMP=$(mktemp)
+					tail -n +2 $WAITLIST > $TEMP
+					cp $TEMP $WAITLIST
+					rm $TEMP
+					unset TEMP
+					echo 0 > $WAITLIST_LCK
 					break
 				fi
 			done
 			break
 		else
-			if [[ -z "$(grep $1 $REPODIR/.waitlist)" ]]; then
+			if [[ -z "$(grep $1 $WAITLIST)" ]]; then
 				# Not on waitlist for some reason, need to readd
-				if [[ $(cat $REPODIR/.waitlist.lck) == 1 ]]; then
+				if [[ $(cat $WAITLIST_LCK) == 1 ]]; then
 					sleep 1
 				else
-					echo 1 > $REPODIR/.waitlist.lck
-					echo $1 >> $REPODIR/.waitlist
-					echo 0 > $REPODIR/.waitlist.lck
+					echo 1 > $WAITLIST_LCK
+					echo $1 >> $WAITLIST
+					echo 0 > $WAITLIST_LCK
 				fi
 			fi
 			sleep 10
@@ -141,8 +162,8 @@
 	#Currently old package versions stay in the repodir indefinately
 	# while [ $NUM_OLD \< $(find . -name '*.pkg.tar.xz' | wc -l) ]
 	# do
-	# 	old=$(newold_matching_file o '*.pkg.tar.xz')
-	# 	rm $REPODIR/$old $old
+	#	old=$(newold_matching_file o '*.pkg.tar.xz')
+	#	rm $REPODIR/$old $old
 	# done
 	return 0
 }
@@ -155,8 +176,6 @@
 		sudo pacman -Syu --noconfirm
 	fi
 
-	#Remove waitlist and errors from old builds
-	rm -f $REPODIR/{.waitlist,.errors}
 	#update every package currently stored
 	for d in $(find $BUILDDIR -maxdepth 1 -mindepth 1 -type d)
 	do
@@ -173,7 +192,7 @@
 }
 
 #Add a new package to be built
-#Adding build dependencies is 
+#Adding build dependencies is
 # Usage: add [package name]
 function add {
 	for i in $@; do
@@ -187,7 +206,7 @@
 
 		#check for all build dependencies
 		for i in ${makedepends[@]}; do
-			if pacman -Si $i; then 
+			if pacman -Si $i; then
 				makedepends=${makedepends[@]/$delete}
 			fi &>/dev/null
 		done
@@ -205,14 +224,50 @@
 }
 
 #Remove a package from the build list and repository
-# Usage remove [package name]
+#Usage of -a removes all packages moved to official repos
+# Usage remove [-a|package name]
 function remove {
-	for i in $@; do
-		rm -rf $BUILDDIR/$i
-		repo-remove $REPODIR/$REPONAME.db.tar.xz $i
-		rm -f $REPODIR/*$i*
-	done
+	if [[ "$1" == "-a" ]]; then
+		rmlist=""
+		rmlist="$rmlist $(comm -12 <(pacman -Slq $REPONAME | sort) <(pacman -Slq core | sort) | tr '\n' ' ')"
+		rmlist="$rmlist $(comm -12 <(pacman -Slq $REPONAME | sort) <(pacman -Slq extra | sort) | tr '\n' ' ')"
+		rmlist="$rmlist $(comm -12 <(pacman -Slq $REPONAME | sort) <(pacman -Slq community | sort) | tr '\n' ' ')"
+		for i in $rmlist; do
+			rm -rf $BUILDDIR/$i
+			repo-remove $([[ "$SIGN" == "Y" ]] && echo "--sign --key $KEY") $REPODIR/$REPONAME.db.tar.$([ -n "$COMPRESSION" ] || echo $COMPRESSION && echo zst) $i
+			rm -f $REPODIR/*$i*
+		done
+	else
+		for i in $@; do
+			rm -rf $BUILDDIR/$i
+			repo-remove $([[ "$SIGN" == "Y" ]] && echo "--sign --key $KEY") $REPODIR/$REPONAME.db.tar.$([ -n "$COMPRESSION" ] || echo $COMPRESSION && echo zst) $i
+			rm -f $REPODIR/*$i*
+		done
+	fi
 }
+
+#Check for packages moved to official repos or removed from the AUR
+function check {
+	rmlist=""
+	rmlist="$rmlist $(comm -12 <(pacman -Slq $REPONAME | sort) <(pacman -Slq core | sort) | tr '\n' ' ')"
+	rmlist="$rmlist $(comm -12 <(pacman -Slq $REPONAME | sort) <(pacman -Slq extra | sort) | tr '\n' ' ')"
+	rmlist="$rmlist $(comm -12 <(pacman -Slq $REPONAME | sort) <(pacman -Slq community | sort) | tr '\n' ' ')"
+	TMPFILE=$(mktemp)
+	for i in $(find $BUILDDIR -mindepth 1 -maxdepth 1 -type d); do
+		check_pkg $TMPFILE "$(echo $i | rev | cut -d'/' -f1 | rev)" &
+	done
+	wait
+	echo "Merged into official repos: $rmlist"
+	echo "Not in AUR: $(cat $TMPFILE | tr '\n' ' ')"
+	rm -f $TMPFILE
+}
+
+function check_pkg {
+	if [[ -z "$(curl -sI "https://aur.archlinux.org/packages/$2" | head -n1 | grep 200)" ]]; then
+		echo "$2" >> $1
+	fi
+}
+
 
 #Check config and create build folders
 #Set variables before usage
@@ -280,19 +335,29 @@
 		build_all $([[ "$2" == "-f" ]] && echo "-f");;
 	"remove")
 		remove ${@:2};;
+	"check")
+		check;;
 	*)
-		printf "Invalid usage\nUsage: $0 init|add|build-all\n";;
+		echo -e "\033[0;31mInvalid usage\033[0m"
+		echo -e "Usage: $0 init|check|add|remove|build-all"
+		echo -e "\033[0;32minit\033[0m                        - initialise repository for use"
+		echo -e "\033[0;32mcheck\033[0m                       - check if packages have been moved into the official repositories or removed from the AUR"
+		echo -e "\033[0;32madd package ...\033[0m             - add a package to \$BUILDDIR and repository, also used to rebuild failed packages"
+		echo -e "\033[0;32mremove -a | package ...\033[0m     - remove package from \$BUILDDIR and repository, \"-a\" removes packages added to official repos"
+		echo -e "\033[0;32mbuild-all [-f]\033[0m              - build all packages in \$BUILDDIR, \"-f\" force builds whole repository"
 esac
 
 # Error reporting, send email only for build-all as assuming an batch job for that
-if [[ -f $REPODIR/.errors ]]; then
-	ERRORS=$(cat $REPODIR/.errors | tr '\n' ' ')
-	rm $REPODIR/.errors
-	echo "Errors in packages: $ERRORS"
-	if [[ "$EMAIL" != "" && "$1" == "build-all" ]]; then
-		send_email $ERRORS
+if [[ $1 == "build-all" || $1 == "add" ]]; then
+	if [[ -n $(cat $ERRORFILE) ]]; then
+		ERRORS=$(cat $ERRORFILE | tr '\n' ' ')
+		echo "Errors in packages: $ERRORS"
+		if [[ "$EMAIL" != "" && "$1" == "build-all" ]]; then
+			send_email $ERRORS
+		fi
+	else
+		echo "All packages built successfully"
 	fi
-else
-	echo "All packages built successfully"
 fi
 
+rm $ERRORFILE $WAITLIST $WAITLIST_LCK

--
Gitblit v1.9.3